<script lang="ts">
    import type { Account, Bankcard, Transaction } from "@/utils/types";
	import { Button, Card, Dialog, H1, H2, H3, Label, Modal, TextField } from "attractions";
	import { page } from "$app/stores";
    import { createEventDispatcher } from "svelte";
    import FormCard from "./FormCard.svelte";

	export let card: Bankcard;

	$: form = $page.form;

	const dispatch = createEventDispatcher<{update_data: null}>();
	let settings_modal = false;

	let fields = [
		["Név", "name", "text", "reorder", card.name],
		["Felvétel limit", "take_limit", "number", "attach_money", card.take_limit],
		["Vásárlási limit", "purchase_limit", "number", "attach_money", card.purchase_limit],
	];
</script>

<Modal bind:open={settings_modal} let:closeCallback>
	<div class="dialog-wrapper">
		<Dialog {closeCallback} title={`'${card.name}' beállításai`}>
			<div class="dialog-content">
				<FormCard {fields} width="100%" form_action="?/update_card" use_enhance={false}>
					<svelte:fragment slot="fields">
						<input type="hidden" name="card_number" value={card.number}>
					</svelte:fragment>
					<svelte:fragment slot="actions">
						<Button type="submit">Módosít</Button>
					</svelte:fragment>
				</FormCard>
			</div>
		</Dialog>
	</div>
</Modal>

<div class="card-wrapper">
	<Card tight>
		<div class="card-content">
			<div class="top">
				{card.name}
				<div class="settings-button">
					<Button neutral round on:click={() => (settings_modal = true)}>
						<i class="material-icons settings-icon">settings</i>
					</Button>
				</div>
			</div>
			<div class="bottom">
				{card.number.match(/.{1,4}/g)?.join(' ')} <!-- Separate with space every 4 characters -->
			</div>
		</div>
	</Card>
</div>

<style lang="scss">
	.dialog-wrapper {
		width: 550px;
	}
	.card-wrapper {
		position: relative;
		width: 350px;
		transition: .3s scale;
	}
	.card-content {
		display: flex;
		width: 100%;
		flex-direction: column;
	}
	$dark: rgba(0, 0, 0, 0.5);
	.top {
		display: flex;
		align-items: flex-end;
		padding-left: 6px;
		color: black;
		height: 105px;
		background-color: whitesmoke;
	}
	.settings-button {
		position: absolute;
		right: 6px; top: 6px;
	}
	.settings-icon {
		color: $dark;
	}
	.bottom {
		padding: 24px 12px;
		color: whitesmoke;
		background-color: $dark;
	}
</style>